#pragma semicolon 1

#include <sourcemod>
#include <sdkhooks>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP [Tears of Denial]",
	author	= "wS",
	version = "1.0.6"
};

#define ITEM_NAME "tears_of_denial"
new bool:g_bAccess[MAXPLAYERS + 1];

new bool:g_bUsed[MAXPLAYERS + 1];
new bool:g_bDmgSelf, bool:g_bDmgPlayerOnly, bool:g_bDmgHeadshot;
new bool:mp_friendlyfire_on;
new g_HitGroup[MAXPLAYERS + 1] = {-1, ...};

#define	HITGROUP_HEAD 1

public OnPluginStart()
{
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_TOGGLE)) {
		SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);
	}
	
	LoadTranslations("vip_modules_description.phrases");
	
	//
	new Handle:hCvar;
	
	hCvar				= CreateConVar("tod_dmg_self"		, "1", "", _, true, 0.0, true, 1.0);
	g_bDmgSelf			= GetConVarBool(hCvar);
	HookConVarChange(hCvar, CvarChanged);
	
	hCvar 				= CreateConVar("tod_dmg_playeronly"	, "1", "", _, true, 0.0, true, 1.0);
	g_bDmgPlayerOnly	= GetConVarBool(hCvar);
	HookConVarChange(hCvar, CvarChanged);
	
	hCvar 				= CreateConVar("tod_dmg_headshot"	, "1", "", _, true, 0.0, true, 1.0);
	g_bDmgHeadshot 		= GetConVarBool(hCvar);
	HookConVarChange(hCvar, CvarChanged);
	
	AutoExecConfig(true, ITEM_NAME, "vip/modules/tears_of_denial");
	//
	
	if ((hCvar = FindConVar("mp_friendlyfire")) != INVALID_HANDLE)
	{
		mp_friendlyfire_on = GetConVarInt(hCvar) != 0;
		HookConVarChange(hCvar, cvar_mp_friendlyfire);
	}
	
	HookEvent("player_spawn", player_spawn, EventHookMode_Post);
}

public CvarChanged(Handle:hCvar, const String:OldValue[], const String:NewValue[])
{
	decl String:n[32];
	GetConVarName(hCvar, n, sizeof(n));
	if (	 !strcmp(n[8], "self"		, false)) { g_bDmgSelf		 = bool:StringToInt(NewValue); }
	else if (!strcmp(n[8], "playeronly"	, false)) { g_bDmgPlayerOnly = bool:StringToInt(NewValue); }
	else if (!strcmp(n[8], "headshot"	, false)) { g_bDmgHeadshot	 = bool:StringToInt(NewValue); }
}

public cvar_mp_friendlyfire(Handle:hCvar, const String:OldValue[], const String:NewValue[]) {
	mp_friendlyfire_on = StringToInt(NewValue) != 0;
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_bAccess[client])
	{
		IntToString(1, ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public bool:VIP_Description(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], String:description[], description_size)
{
	FormatEx(description, description_size, "%T", ITEM_NAME, client);
	return true;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	if (g_bAccess[client]) { return VGA_AlreadyEnabled; }
	SetStatus(client, true);
	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient) {
	SetStatus(client, false);
}

stock SetStatus(client, bool:enabled)
{
	SDKUnhook(client, SDKHook_TraceAttackPost, TraceAttackPost);
	SDKUnhook(client, SDKHook_OnTakeDamage, OnTakeDamage);
	
	if ((g_bAccess[client] = enabled))
	{
		SDKHook(client, SDKHook_TraceAttackPost, TraceAttackPost); // Получить hitgroup. В SDKHook_TraceAttack.. неверное 'damage' при тесте с ботом.
		SDKHook(client, SDKHook_OnTakeDamage, OnTakeDamage);
	}
	
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, enabled);
}

///////////////////////////////////////////////////////////////////////////////////

public TraceAttackPost(victim, attacker, inflictor, Float:damage, damagetype, ammotype, hitbox, hitgroup) {
	g_HitGroup[victim] = hitgroup;
}

public Action:OnTakeDamage(victim, &attacker, &inflictor, &Float:damage, &damagetype)
{
	if (g_bAccess[victim] && !g_bUsed[victim] && IsClientInGame(victim) && damage >= float(GetEntProp(victim, Prop_Send, "m_iHealth")))
	{
		if ((damagetype & /*64*/DMG_BLAST) && inflictor > MaxClients) // c4 explode
		{
			decl String:class[32];
			if (GetEntityClassname(inflictor, class, sizeof(class)) && !strcmp(class, "planted_c4", false)) {
				return Plugin_Continue;
			}
		}
	
		if (g_bDmgPlayerOnly && (attacker < 1 || attacker > MaxClients)) {
			return Plugin_Continue;
		}
		
		if (victim == attacker && !g_bDmgSelf) {
			return Plugin_Continue;
		}
		
		if (!g_bDmgHeadshot && g_HitGroup[victim] == HITGROUP_HEAD && (damagetype & /*2*/DMG_BULLET)) {
			return Plugin_Continue;
		}
		
		if (!mp_friendlyfire_on
			&& victim != attacker
			&& attacker > 0
			&& attacker <= MaxClients
			&& IsClientInGame(attacker)
			&& GetClientTeam(attacker) == GetClientTeam(victim))
		{
			return Plugin_Continue; // bug fix?
		}
		
		g_bUsed[victim] = true;
		SetEntProp(victim, Prop_Send, "m_iHealth", 1);
		return Plugin_Handled;
	}
	return Plugin_Continue;
}

public player_spawn(Handle:event, const String:name[], bool:silent) {
	g_bUsed[GetClientOfUserId(GetEventInt(event, "userid"))] = false;
}

public OnClientDisconnect_Post(client) {
	g_bAccess[client] = false;
}